import{tsv, json,csv} from 'd3';
import { feature } from 'topojson';

export const loadAndProcessData = () => 
  Promise
    .all([
      tsv('https://unpkg.com/world-atlas@1.1.4/world/50m.tsv'),
      json('https://unpkg.com/world-atlas@1.1.4/world/50m.json'),
      csv('https://vizhub.com/jons288/datasets/travelers.csv')
    ])
    .then(([tsvData, topoJSONdata,csvData]) => {
      
    
      const rowById = tsvData.reduce((accumulator, d) => {
        accumulator[d.iso_n3] = d;
       return accumulator;
      }, {});
      
      const rowByCountry = csvData.reduce((accumulator, d) => {
        accumulator[d.Country] = d;
       return accumulator;
      }, {});
      
      const countries = feature(topoJSONdata, topoJSONdata.objects.countries);

      countries.features.forEach(d => {
        Object.assign(d.properties,rowById[d.id]) 
        Object.assign(d.properties,rowByCountry[d.properties['name']])  
        d.properties.Travelers ? null : Object.assign(d.properties,{Travelers:'NA'})
      
      });
      return countries;    
    });     